/// <reference types="react" />
import { EditablePropMap } from "./registry/EditableProps";
export declare enum BlockTypes {
    title = "@codeblog/title",
    header = "@codeblog/header",
    paragraph = "@codeblog/paragraph",
    blockquote = "@codeblog/blockquote"
}
export declare enum CategoryType {
    inline = "text",
    block = "block",
    header = "header",
    text = "text",
    media = "media",
    embed = "embed"
}
export declare type BackgroundProp = string;
export declare type ColorProp = string;
export declare type AlignProp = "left" | "right" | "center";
export { EditableProps } from "./registry/EditableProps";
export declare type CodeblogPackageJSON = {
    name: string;
    version: string;
    license: "MIT";
    codeblog: {
        title: string;
        description: string;
        screenshot?: string;
        editableProps?: EditablePropMap;
        defaultProps?: {
            [key: string]: string;
        };
    };
    dependencies: {
        [key: string]: string;
    };
};
export declare type ComponentManifest = {
    title: string;
    description: string;
    screenshot: string | null;
    category: CategoryType;
    placeholder: string | null;
    isDevelopment?: boolean;
    src: string | null;
    isRemote: boolean;
    isVoid?: boolean;
    Component: React.ComponentType<any> | null;
    EditorComponent: React.ComponentType<any> | null;
    editableProps?: EditablePropMap;
    defaultProps?: {
        [key: string]: string;
    };
    id: string;
};
