(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./registry/EditableProps"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./registry/EditableProps"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.EditableProps);
    global.registry = mod.exports;
  }
})(this, function (_exports, _EditableProps) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  Object.defineProperty(_exports, "EditableProps", {
    enumerable: true,
    get: function get() {
      return _EditableProps.EditableProps;
    }
  });
  _exports.CategoryType = _exports.BlockTypes = void 0;
  var BlockTypes;
  _exports.BlockTypes = BlockTypes;

  (function (BlockTypes) {
    BlockTypes["title"] = "@codeblog/title";
    BlockTypes["header"] = "@codeblog/header";
    BlockTypes["paragraph"] = "@codeblog/paragraph";
    BlockTypes["blockquote"] = "@codeblog/blockquote";
  })(BlockTypes || (_exports.BlockTypes = BlockTypes = {}));

  var CategoryType; // This will be fancier later.

  _exports.CategoryType = CategoryType;

  (function (CategoryType) {
    CategoryType["inline"] = "text";
    CategoryType["block"] = "block";
    CategoryType["header"] = "header";
    CategoryType["text"] = "text";
    CategoryType["media"] = "media";
    CategoryType["embed"] = "embed";
  })(CategoryType || (_exports.CategoryType = CategoryType = {}));
});