(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "@emotion/core", "react", "scriptjs"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("@emotion/core"), require("react"), require("scriptjs"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.core, global.react, global.scriptjs);
    global.ComponentLoader = mod.exports;
  }
})(this, function (_exports, _core, _react, _scriptjs) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ComponentLoader = void 0;
  _react = _interopRequireDefault(_react);
  _scriptjs = _interopRequireDefault(_scriptjs);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

  function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

  function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

  function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

  function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  var getModule = function getModule(moduleName) {
    return window[moduleName];
  };

  var loadScript = function loadScript(url) {
    return new Promise(function (resolve, reject) {
      (0, _scriptjs["default"])(url, function () {
        return resolve();
      }, function () {
        return reject();
      });
    });
  };

  var loadAndEvalScript =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(url, moduleName) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return loadScript(url);

            case 2:
              return _context.abrupt("return", getModule(moduleName));

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function loadAndEvalScript(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  var ComponentLoader =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(ComponentLoader, _React$Component);

    function ComponentLoader(props) {
      var _this;

      _classCallCheck(this, ComponentLoader);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(ComponentLoader).call(this, props));

      _defineProperty(_assertThisInitialized(_this), "Component", void 0);

      _defineProperty(_assertThisInitialized(_this), "loadComponent",
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var cacheBust,
            _args2 = arguments;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                cacheBust = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : false;
                _context2.prev = 1;
                _context2.next = 4;
                return loadAndEvalScript(cacheBust ? _this.props.src + "?d=".concat(new Date().getTime()) : _this.props.src, _this.props.moduleName);

              case 4:
                _this.Component = _context2.sent;

                _this.setState({
                  status: "completed",
                  error: null
                });

                _context2.next = 12;
                break;

              case 8:
                _context2.prev = 8;
                _context2.t0 = _context2["catch"](1);
                console.error(_context2.t0);

                _this.setState({
                  error: _context2.t0,
                  status: "error"
                });

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[1, 8]]);
      })));

      _this.Component = getModule(props.moduleName);
      _this.state = {
        status: _this.Component ? "completed" : "loading",
        error: null
      };
      return _this;
    }

    _createClass(ComponentLoader, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        if (this.state.status === "loading") {
          this.loadComponent(false);
        }
      }
    }, {
      key: "componentDidCatch",
      value: function componentDidCatch(error) {
        console.error("[".concat(this.props.moduleName, "]"), error);
        this.setState({
          status: "error"
        });
      }
    }, {
      key: "render",
      value: function render() {
        var status = this.state.status;
        var Component = this.Component;

        if (status === "completed") {
          return (0, _core.jsx)(Component, _extends({
            ref: this.props.innerRef
          }, this.props.componentProps), this.props.children);
        } else {
          return _react["default"].createElement(this.props.wrapperTagName, {
            ref: this.props.innerRef
          }, this.props.children);
        }
      }
    }], [{
      key: "getDerivedStateFromError",
      value: function getDerivedStateFromError(_error) {
        return {
          status: "error"
        };
      }
    }]);

    return ComponentLoader;
  }(_react["default"].Component);

  _exports.ComponentLoader = ComponentLoader;
});