(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "./Components", "./Blog", "./BlogPost"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("./Components"), require("./Blog"), require("./BlogPost"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.Components, global.Blog, global.BlogPost);
    global.index = mod.exports;
  }
})(this, function (_exports, Components, _Blog, _BlogPost) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  Object.defineProperty(_exports, "Blog", {
    enumerable: true,
    get: function get() {
      return _Blog.Blog;
    }
  });
  Object.defineProperty(_exports, "BlogPost", {
    enumerable: true,
    get: function get() {
      return _BlogPost.BlogPost;
    }
  });
  _exports.Components = _exports.styles = void 0;
  Components = _interopRequireWildcard(Components);
  _exports.Components = Components;

  function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

  var styles = "#__codeblog,#__codeblog-content,html,body,div,span,applet,object,iframe,blockquote,pre,a,ul,li,ol,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video{margin:0;padding:0;border:0;font-family:inherit;vertical-align:baseline;}html{scroll-behavior:smooth;}*{box-sizing:border-box;}:root{--monospace-font:\"Inconsolata\", monospace;--body-font:\"Source Serif Pro\", sans-serif;--headings-font:\"Work Sans\", -apple-system, BlinkMacSystemFont, \"Segoe UI\",\n    Roboto, Helvetica, Arial, sans-serif, \"Apple Color Emoji\", \"Segoe UI Emoji\",\n    \"Segoe UI Symbol\";--offset-small:4px;--offset-snormal:8px;--offset-normal:14px;--offset-xnormal:12px;--offset-medium:20px;--offset-big:38px;--offset-large:64px;--color-dark:rgb(31, 31, 31);--color-black:rgb(13, 9, 13);--color-white:rgb(255, 255, 255);--color-dark-gray:rgb(83, 83, 83);--color-medium-gray:rgb(92, 92, 92);--color-light-gray:rgb(233, 233, 233);--color-primary:rgb(224, 55, 55);--color-primary-muted:rgba(224, 55, 55, 0.45);--color-error:rgb(199, 14, 14);--color-muted:#979797;--border-radius:4px;--page-background:var(--color-white);--page-background-offset:var(--color-light-gray);--text-color:var(--color-dark);--text-dark-color:var(--color-black);--link-color:var(--text-color);--blog-width:100%;--blog-post-width:686px;}code{font-family:var(--monospace-font);}*{box-sizing:border-box;}body{color:var(--text-color);background-color:var(--page-background);transition:background-color 0.1s linear;transition-property:background-color, color;font-family:var(--headings-font);font-size:21px;}h1,h2,h3,h4,h5,h6{margin-block-start:var(--offset-big);line-height:1.35;font-weight:600;font-family:var(--headings-font);position:relative;margin-block-end:0;}.BlogPost-Title,h1,h2,h3,h4,h5,h6,strong{color:var(--text-dark-color);}a,a:visited{color:var(--link-color);}.Blog{width:100%;margin:0;}.BlogPost{width:100%;margin-top:var(--offset-large);margin-bottom:var(--offset-large);color:var(--text-color);text-rendering:optimizeLegibility;line-height:1.6;font-family:var(--body-font);}.BlogPost-Body:first-child{margin-top:0;}.BlogPost-Body{padding-left:calc((100vw - var(--blog-post-width)) / 2);padding-right:calc((100vw - var(--blog-post-width)) / 2);width:100%;word-wrap:break-word;}.BlogHeader{--page-background:var(--color-black);padding:var(--offset-normal);background-color:var(--page-background);}.BlogHeaderContent{display:flex;align-items:center;text-decoration:none;background-color:var(--page-background);--text-color:var(--color-white);}a.BlogHeaderContent:hover{text-decoration:underline;}.BlogTitle{font-size:16px;font-weight:600;color:var(--text-color);}.BlogHeader-image{border-radius:50%;display:flex;margin-right:var(--offset-normal);}.BlogHeader-image--fallback{height:30px;width:30px;background-color:var(--text-color);border:2px solid var(--color-primary);}.BlogPost img{max-width:100%;}blockquote{border-left:10px solid var(--text-color);padding-left:var(--offset-medium);}ol,ul{margin-top:var(--offset-normal);margin-bottom:var(--offset-normal);}li{margin-block-start:var(--offset-normal);padding-top:var(-offset-small);padding-bottom:var(-offset-small);margin-block-end:var(--offset-normal);}ol li:last-of-type,ul li:last-of-type{margin-block-end:0;}.BlogPost-Title{margin-block-start:0;margin-block-end:0;font-size:1.9em;line-height:1.15;}.BlogPost-Subtitle{margin-block-end:0;margin-block-start:0;display:flex;color:var(--color-muted);font-weight:600;font-family:var(--headings-font);font-size:0.7em;}.Separator{background-color:currentColor;border-radius:50%;content:\"\";margin-top:auto;margin-bottom:auto;display:inline-block;}.Separator--small{margin-left:var(--offset-small);margin-right:var(--offset-small);width:2px;height:2px;}.BlogIndex-description{white-space:pre-line;}.BlogPost--index{margin-top:var(--offset-medium);margin-bottom:var(--offset-medium);}kbd{cursor:pointer;color:#fcfcfc;background:#222;box-shadow:inset 0 0 25px #333, 0 1px 0 #000, 0 2px 0 #222, 0 2px 3px #333;text-shadow:0px -1px 0px #000;font-family:-apple-system, BlinkMacSystemFont, \"Segoe UI\", Roboto, Oxygen, Ubuntu, Cantarell, \"Open Sans\", \"Helvetica Neue\", sans-serif;text-decoration:none;text-align:center;width:2.2em;height:2em;border-radius:var(--border-radius);display:inline-flex;justify-content:center;align-items:center;border-top:1px solid rgba(255, 255, 255, 0.8);margin:0px;}@media (max-width: 680px){.BlogPost-Body > section,.BlogPost-Body{padding-left:var(--offset-normal);padding-right:var(--offset-normal);}}@media (-webkit-min-device-pixel-ratio: 1.5){*{-webkit-font-smoothing:antialiased;}}@font-face{font-family:\"Source Serif Pro\";font-style:normal;font-weight:400;src:local(\"Source Serif Pro\"), local(\"SourceSerifPro-Regular\"), url(https://fonts.gstatic.com/s/sourceserifpro/v6/neIQzD-0qpwxpaWvjeD0X88SAOeauXo-oAGIyY0Wfw.woff2) format(\"woff2\");unicode-range:U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF;}@font-face{font-family:\"Source Serif Pro\";font-style:normal;font-weight:400;src:local(\"Source Serif Pro\"), local(\"SourceSerifPro-Regular\"), url(https://fonts.gstatic.com/s/sourceserifpro/v6/neIQzD-0qpwxpaWvjeD0X88SAOeauXQ-oAGIyY0.woff2) format(\"woff2\");unicode-range:U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;}@font-face{font-family:\"Source Serif Pro\";font-style:normal;font-weight:700;src:local(\"Source Serif Pro Bold\"), local(\"SourceSerifPro-Bold\"), url(https://fonts.gstatic.com/s/sourceserifpro/v6/neIXzD-0qpwxpaWvjeD0X88SAOeasc8btSKqxKcsdrOPbQ.woff2) format(\"woff2\");unicode-range:U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF;}@font-face{font-family:\"Source Serif Pro\";font-style:normal;font-weight:700;src:local(\"Source Serif Pro Bold\"), local(\"SourceSerifPro-Bold\"), url(https://fonts.gstatic.com/s/sourceserifpro/v6/neIXzD-0qpwxpaWvjeD0X88SAOeasc8btSyqxKcsdrM.woff2) format(\"woff2\");unicode-range:U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;}@font-face{font-family:\"Work Sans\";font-style:normal;font-weight:600;src:local(\"Work Sans SemiBold\"), local(\"WorkSans-SemiBold\"), url(https://fonts.gstatic.com/s/worksans/v4/QGYpz_wNahGAdqQ43Rh3o4T8lthNy_r-K7mV.woff2) format(\"woff2\");unicode-range:U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF;}@font-face{font-family:\"Work Sans\";font-style:normal;font-weight:600;src:local(\"Work Sans SemiBold\"), local(\"WorkSans-SemiBold\"), url(https://fonts.gstatic.com/s/worksans/v4/QGYpz_wNahGAdqQ43Rh3o4T8mNhNy_r-Kw.woff2) format(\"woff2\");unicode-range:U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;}@font-face{font-family:\"Inconsolata\";font-style:normal;font-weight:400;src:local(\"Inconsolata Regular\"), local(\"Inconsolata-Regular\"), url(https://fonts.gstatic.com/s/inconsolata/v17/QldKNThLqRwH-OJ1UHjlKGlW5qhExfHwNJU.woff2) format(\"woff2\");unicode-range:U+0102-0103, U+0110-0111, U+1EA0-1EF9, U+20AB;}@font-face{font-family:\"Inconsolata\";font-style:normal;font-weight:400;src:local(\"Inconsolata Regular\"), local(\"Inconsolata-Regular\"), url(https://fonts.gstatic.com/s/inconsolata/v17/QldKNThLqRwH-OJ1UHjlKGlX5qhExfHwNJU.woff2) format(\"woff2\");unicode-range:U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF;}@font-face{font-family:\"Inconsolata\";font-style:normal;font-weight:400;src:local(\"Inconsolata Regular\"), local(\"Inconsolata-Regular\"), url(https://fonts.gstatic.com/s/inconsolata/v17/QldKNThLqRwH-OJ1UHjlKGlZ5qhExfHw.woff2) format(\"woff2\");unicode-range:U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;}";
  _exports.styles = styles;
});